reflex::Pattern::DFA::State Struct Reference

|  | reflex::Pattern::DFA::State Struct Reference updated Thu Jun 19 2025 by Robert van Engelen |

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | List of all members
reflex::Pattern::DFA::State Struct Reference

`#include <pattern.h>`

Inheritance diagram for reflex::Pattern::DFA::State:
[legend]
Collaboration diagram for reflex::Pattern::DFA::State:
[legend]

## Public Types
typedef std::pair< Char, State * > | Edge
| hi of char range [lo,hi] and state to transition to More...
typedef std::map< Char, Edge > | Edges
| maps lo to hi and state to transition to on char in range [lo,hi] More...

## Public Member Functions
| State ()

## Public Attributes
State * | next
| points to next state in the list of states allocated depth-first by subset construction More...
State * | left
| left pointer for O(log N) node insertion in the hash table overflow tree More...
State * | right
| right pointer for O(log N) node insertion in the hash table overflow tree More...
State * | tnode
| the corresponding tree DFA node, when applicable More...
Edges | edges
| state transitions More...
Lookaheads | heads
| lookahead head set More...
Lookaheads | tails
| lookahead tail set More...
Index | first
| index of this state in the opcode table in the first assembly pass, also used in breadth-first search to cut DFA for predict match More...
Index | index
| index of this state in the opcode table, also used in HFA construction More...
Accept | accept
| nonzero if final state, the index of an accepted/captured subpattern More...
bool | redo
| true if this is a final state of a negative pattern More...

## Member Typedef Documentation

typedef std::pair<Char,State*> reflex::Pattern::DFA::State::Edge

hi of char range [lo,hi] and state to transition to

typedef std::map<Char,Edge> reflex::Pattern::DFA::State::Edges

maps lo to hi and state to transition to on char in range [lo,hi]

## Constructor & Destructor Documentation

reflex::Pattern::DFA::State::State | ( |  | ) |
| inline

## Member Data Documentation

Accept reflex::Pattern::DFA::State::accept

nonzero if final state, the index of an accepted/captured subpattern

Edges reflex::Pattern::DFA::State::edges

state transitions

Index reflex::Pattern::DFA::State::first

index of this state in the opcode table in the first assembly pass, also used in breadth-first search to cut DFA for predict match

Lookaheads reflex::Pattern::DFA::State::heads

lookahead head set

Index reflex::Pattern::DFA::State::index

index of this state in the opcode table, also used in HFA construction

State* reflex::Pattern::DFA::State::left

left pointer for O(log N) node insertion in the hash table overflow tree

State* reflex::Pattern::DFA::State::next

points to next state in the list of states allocated depth-first by subset construction

bool reflex::Pattern::DFA::State::redo

true if this is a final state of a negative pattern

State* reflex::Pattern::DFA::State::right

right pointer for O(log N) node insertion in the hash table overflow tree

Lookaheads reflex::Pattern::DFA::State::tails

lookahead tail set

State* reflex::Pattern::DFA::State::tnode

the corresponding tree DFA node, when applicable

The documentation for this struct was generated from the following file:

- pattern.h